
extern "C" {
#include "fv_milter_queue_client.h"
}

#include <iostream>
#include <string>
#include <sys/types.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <stdio.h>
#include <syslog.h>
#include <sstream>
#include <stdexcept>
#include <unistd.h>

using namespace std;

struct ConversionErr {};

inline std::string tostring(long l)
 {
   std::ostringstream o;
   if (!(o << l))
     throw ConversionErr();
   return o.str();
 }

void send_message(int fd, const string& msg, int debug)
{

	unsigned int rslt;
	unsigned int sz = 4096;
	string s = msg;
	s += "\r\n";
	char buf[sz];

	long msg_len = htonl(s.length());
	if(debug) {
		syslog(LOG_INFO, "Write: expect to write: %ld", msg_len);
	}		
	
	/* write the length header */
	write(fd, (void*) &msg_len, sizeof(long));
	
	while(1) {
	
		if(debug) {
			syslog(LOG_INFO, "Write: top of while 1, msg is: %s", msg.c_str());
		}
	
		char* pbuf = buf;
		memset(buf, 0, sz);		
		strncpy(buf, s.c_str(), (sz - 1));
		if(s.length() > (sz - 1)) {
			s = s.substr((sz - 1), (s.length() - 1));
		} else {
			/* last write */
			s = "";
		}
		
		while(1) {
		
			if(debug) {
				syslog(LOG_INFO, "Write: top of while 2, pbuf is: %s", pbuf);
			}
		
			rslt = write(fd, pbuf, strlen(buf));
			if(rslt == 0) {
				goto send_msg_out;
			}
			
			if(rslt > 0 ) {
				if(rslt >= strlen(buf)) {
					/* wrote everything in buf */
					break;
				}
				pbuf += rslt;
			} else {
				if(errno != EINTR) {
					perror("Error on fd read: ");
					goto send_msg_out;
				}
			}
						
		} // while 2
		
		if(s.length() <= 0) {
			/* done with msg */
			break;
		}
		
	} // while 1
	
send_msg_out:
	return;	
}

extern "C"  {

int sendmail_queue_message(const char* msg, int debug)
{
	int rslt = 0;
	int servfd;
	struct sockaddr_un srvaddr;
	const string socket_path = "/var/run/fv_milter_queued.sock";

	try {

		servfd = socket(PF_UNIX, SOCK_STREAM, 0);
		memset(&srvaddr, 0, sizeof(srvaddr));

		/* Is this safe? Yes, if path < 108 bytes */
		srvaddr.sun_family = PF_UNIX;
		strcpy(srvaddr.sun_path, socket_path.c_str());
		socklen_t srvlen = sizeof(srvaddr);

		/* Setup */
		int connect_rslt = connect(servfd, (struct sockaddr*) &srvaddr, srvlen);
		if(connect_rslt != 0) {
			perror("Error connecting to socket: ");
			rslt = 1;
			throw(0);
		}
	
		send_message(servfd, string(msg), debug);
	
	} // try

	catch(...) {
		// do something?
	}

	return rslt;
}

} // extern "C"


