#!/bin/bash

milter_dir=/opt/fv_milter

function check_for_core() {
    rslt=0
    if [ -f $milter_dir/core* ]; then
	rslt=1
    fi
    return $rslt
}

function move_cores() {
    coredir=$milter_dir/csave
    if [ ! -d $coredir ]; then
	mkdir $coredir
    fi
    tm=`date +"%Y%m%d_%H%M"`
    for f in $milter_dir/core*
    do
	bf=`basename $f`
	nf="$coredir/$bf-$tm"
	mv -f $milter_dir/$bf $nf
    done
}

function mail_warning() {
    cores=`ls $milter_dir/core*`
    for u in "$@"; do
	mail -s "Smtp-1 Fv_milter Core File" $u <<EOF
Dear Smtp-1 Admin,

We just got a core file, please check it out:

	$cores

Thx
EOF
    done
}

# main()

check_for_core
if [ $? -ne 0 ]; then
    printf "Found core, yikes\n"
    mail_warning postmaster@mydomain.com
    move_cores
fi

