#ifndef LBX_VACATION_H
#define LBX_VACATION_H

#include "strbuf.h"

typedef struct vacation_msg_struct
{
	string_buffer_t msg;
} vacation_msg;

typedef vacation_msg* vacation_msg_t;

inline vacation_msg_t create_vacation_msg();
inline int delete_vacation_msg(vacation_msg_t vm);
inline int append_to_vacation_msg(vacation_msg_t vm, const char* str);
inline int append_to_vacation_msg_fmt(vacation_msg_t vm, long long size, const char* fmt, ...);

typedef struct vacation_msg_list_struct
{
	vacation_msg_t vmsg;
	struct vacation_msg_list_struct *next;
} vacation_msg_list;

typedef vacation_msg_list* vacation_msg_list_t;

inline vacation_msg_list_t create_vacation_msg_list();
inline long vacation_list_count(vacation_msg_list_t vml);
inline int append_vacation_msg(vacation_msg_list_t vml, vacation_msg_t vm);
inline int delete_vacation_msg_list(vacation_msg_list_t vml);
int send_vacation_messages(const char *mail_cmd, vacation_msg_list_t vml, int debug);

#endif /* LBX_VACATION_H */

